#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

typedef long double TT;

const int maxn = 50010;
const TT eps = 1e-14;

int n;
TT x[maxn],y[maxn],ans;
int seq1[maxn],seq2[maxn],seq[maxn],k1,k2,k;

TT Dist(int a, int b)
{
   return sqrt((x[a]-x[b])*(x[a]-x[b]) + (y[a]-y[b])*(y[a]-y[b]));
}

void Swap(TT &i, TT &j)
{
   TT t = i; i = j; j = t;
}

int Eq(TT a, TT b)
{
   return abs(a-b) < eps;
}

int Less(TT x1, TT y1, TT x2, TT y2)
{
   if (x1 == x2) return y1 < y2; else return x1 < x2;
}

void QSort(int l, int r)
{
   if (l >= r) return;
   int i=l,j=r,k=l+rand()%(r-l+1);
   TT xx=x[k],yy=y[k];
   while (i <= j) {
      while (Less(x[i],y[i],xx,yy)) i++;
      while (Less(xx,yy,x[j],y[j])) j--;
      if (i <= j) {
         Swap(x[i],x[j]); Swap(y[i],y[j]);
         i++; j--;
      }
   }
   QSort(l,j); QSort(i,r);
}

TT Vect(int a, int b, int c)
{
   return (x[c]-x[a])*(y[b]-y[a]) - (y[c]-y[a])*(x[b]-x[a]);
}

TT GD(int a, int b, int c)
{   
   return Vect(a,b,c)*Vect(a,b,c)/((x[b]-x[c])*(x[b]-x[c]) + (y[b]-y[c])*(y[b]-y[c]));
}

int main()
{
   int i,j,sc;
   TT tmp,d,tmp1;
   srand(68943021);

   freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
   scanf("%d",&n);
   for (i = 1; i <= n; i++) scanf("%Lf%Lf",&x[i],&y[i]);
   
   if (n <= 3) {
      ans = 0;
      for (i = 1; i <= n; i++)
         for (j = i+1; j <= n; j++) {
            tmp = Dist(i,j);
            if (tmp > ans) ans = tmp;
         }
   } else {   
      QSort(1,n);
      k1 = 1; seq1[1] = 1;
      for (i = 2; i <= n; i++) {
         while (k1 > 1) {
            if (Vect(seq1[k1-1],seq1[k1],i) > eps) break;
            k1--;
         }
         k1++; seq1[k1] = i;
      }
      k2 = 1; seq2[1] = 1;
      for (i = 2; i <= n; i++) {
         while (k2 > 1) {
            if (Vect(seq2[k2-1],seq2[k2],i) < -eps) break;
            k2--;
         }
         k2++; seq2[k2] = i;
      }
      k = 0;
      for (i = k2; i > 1; i--) {k++; seq[k] = seq2[i];}
      for (i = 1; i <= k1-1; i++) {k++; seq[k] = seq1[i];}      
      seq[k+1] = seq[1]; seq[0] = seq[k];
      
      if (k < 3) {
         ans = 0;
         for (i = 1; i <= k; i++)
            for (j = i+1; j <= k; j++) {
               tmp = Dist(seq[i],seq[j]);
               if (tmp > ans) ans = tmp;
            }      
      } else {
         ans = 0; j = 2;
         for (i = 1; i <= k; i++) {
            d = GD(seq[j],seq[i],seq[i+1]);
            while (1) {
               tmp = GD(seq[j+1],seq[i],seq[i+1]);
               tmp1 = GD(seq[j-1],seq[i],seq[i+1]);
               if (tmp <= d) {
                  if (tmp1 <= d) break;
                  j--; if (j < 1) j += k;                  
                  d = tmp1;
               } else {
                  j++; if (j > k) j -= k;
                  d = tmp;
               }               
            }
            for (sc = j-1; sc <= j+1; sc++) {
               tmp = Dist(seq[i],seq[sc]); if (tmp > ans) ans = tmp;
               tmp = Dist(seq[i+1],seq[sc]); if (tmp > ans) ans = tmp;            
            }
         }
      }
   }
   
   printf("%.7Lf",ans);
   fclose(stdin); fclose(stdout);
   return 0;
}